import { _ as __awaiter, a as __generator } from './_tslib-47e48da1.js';
import main$1 from './home.js';
import kleur from 'kleur';
import main$2 from './root.js';
import main$3 from './toString.js';
import 'os';
import './getType.js';

var cahceTime = [0, ''];
var cacheType = new Map();
var regHome = new RegExp("^".concat(main$1().replace(/\\/g, '\\\\')), 'g');
var regRoot = new RegExp("^".concat(main$2().replace(/\\/g, '\\\\')), 'g');
var separator = "".concat(kleur.gray('›'), " ");
var freeze = function (callback) { return __awaiter(void 0, void 0, void 0, function () {
    var result, _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                main.isFrozen = true;
                main.isSilent = true;
                if (!(typeof callback === 'function')) return [3, 2];
                return [4, callback()];
            case 1:
                _a = _b.sent();
                return [3, 4];
            case 2: return [4, callback];
            case 3:
                _a = _b.sent();
                _b.label = 4;
            case 4:
                result = _a;
                main.isFrozen = false;
                main.isSilent = false;
                return [2, result];
        }
    });
}); };
var main = function () {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    var _a = args.length === 1 ? ['default', args[0]] : args, type = _a[0], message = _a[1];
    if (main.isSilent)
        return message;
    var msg = main$3(message).trim();
    if (!msg)
        return message;
    console.log(render(type, msg));
    return message;
};
var makeTime = function () {
    var date = new Date();
    return [date.getHours(), date.getMinutes(), date.getSeconds()]
        .map(function (it) { return it.toString().padStart(2, '0'); })
        .join(':');
};
var pause = function () {
    if (main.isFrozen)
        return;
    main.isSilent = true;
};
var render = function (type, message) {
    return [renderTime(), separator, renderType(type), renderContent(message)].join('');
};
var renderContent = function (input) {
    return renderPath(input)
        .replace(/'.*?'/g, function (text) { return kleur.magenta(text.replace(/'/g, '') || "''"); });
};
var renderPath = function (input) {
    return input.replace(regRoot, '.').replace(regHome, '~');
};
var renderTime = function () {
    var ts = Math.floor(Date.now() / 1e3);
    if (ts === cahceTime[0])
        return cahceTime[1];
    var result = "".concat(kleur.gray("[".concat(makeTime(), "]")), " ");
    cahceTime[0] = ts;
    cahceTime[1] = result;
    return result;
};
var renderType = function (type) {
    var key = type.trim().toLowerCase();
    if (key === 'default')
        return '';
    if (cacheType.has(key))
        return cacheType.get(key);
    var content = [
        kleur.cyan().underline(key),
        ' '.repeat(Math.max(10 - key.length, 0)),
    ].join('');
    cacheType.set(key, content);
    return content;
};
var resume = function () {
    if (main.isFrozen)
        return;
    main.isSilent = false;
};
var whisper = function (callback) { return __awaiter(void 0, void 0, void 0, function () {
    var result, _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                pause();
                if (!(typeof callback === 'function')) return [3, 2];
                return [4, callback()];
            case 1:
                _a = _b.sent();
                return [3, 4];
            case 2: return [4, callback];
            case 3:
                _a = _b.sent();
                _b.label = 4;
            case 4:
                result = _a;
                resume();
                return [2, result];
        }
    });
}); };
main.freeze = freeze;
main.isFrozen = false;
main.isSilent = false;
main.pause = pause;
main.resume = resume;
main.whisper = whisper;

export { main as default, renderPath };
