import child from 'child_process';
import main$2 from './echo.js';
import kleur from 'kleur';
import main$1 from './os.js';
import { t as trimEnd_1 } from './trimEnd-608117d4.js';
import './_tslib-47e48da1.js';
import './home.js';
import 'os';
import './root.js';
import './toString.js';
import './getType.js';

var separator = main$1() === 'windows' ? ' && ' : '; ';
var info = function (type, message) {
    if (!message)
        return;
    console.log(type === 'error' ? kleur.red(message) : kleur.gray(message));
};
var main = function (cmd, option) {
    if (option === void 0) { option = {}; }
    var stringCmd = cmd instanceof Array ? cmd.join(separator) : cmd;
    var _a = main$1() === 'windows'
        ? ['cmd.exe', ['/s', '/c', stringCmd]]
        : ['/bin/sh', ['-c', stringCmd]], cmder = _a[0], arg = _a[1];
    if (!option.silent)
        main$2('exec', stringCmd);
    return new Promise(function (resolve) {
        var cacheAll = [];
        var cacheLast = '';
        var process = child.spawn(cmder, arg, {});
        process.stderr.on('data', function (data) {
            var message = parseMessage(data);
            cacheAll.push(message);
            cacheLast = message;
            if (!option.silent)
                info('error', message);
        });
        process.stdout.on('data', function (data) {
            var message = parseMessage(data);
            cacheAll.push(message);
            cacheLast = message;
            if (!option.silent)
                info('default', message);
        });
        process.on('close', function (code) { return resolve([code, cacheLast, cacheAll]); });
    });
};
var parseMessage = function (buffer) {
    return trimEnd_1(buffer.toString().trim(), '\n')
        .replace(/\r/g, '\n')
        .replace(/\n{2,}/g, '');
};

export { main as default };
