'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var child = require('child_process');
var echo = require('./echo.js');
var kleur = require('kleur');
var os = require('./os.js');
var trimEnd = require('./trimEnd-0419335b.js');
require('./_tslib-05d1690a.js');
require('./home.js');
require('os');
require('./root.js');
require('./toString.js');
require('./getType.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var child__default = /*#__PURE__*/_interopDefaultLegacy(child);
var kleur__default = /*#__PURE__*/_interopDefaultLegacy(kleur);

var separator = os["default"]() === 'windows' ? ' && ' : '; ';
var info = function (type, message) {
    if (!message)
        return;
    console.log(type === 'error' ? kleur__default["default"].red(message) : kleur__default["default"].gray(message));
};
var main = function (cmd, option) {
    if (option === void 0) { option = {}; }
    var stringCmd = cmd instanceof Array ? cmd.join(separator) : cmd;
    var _a = os["default"]() === 'windows'
        ? ['cmd.exe', ['/s', '/c', stringCmd]]
        : ['/bin/sh', ['-c', stringCmd]], cmder = _a[0], arg = _a[1];
    if (!option.silent)
        echo["default"]('exec', stringCmd);
    return new Promise(function (resolve) {
        var cacheAll = [];
        var cacheLast = '';
        var process = child__default["default"].spawn(cmder, arg, {});
        process.stderr.on('data', function (data) {
            var message = parseMessage(data);
            cacheAll.push(message);
            cacheLast = message;
            if (!option.silent)
                info('error', message);
        });
        process.stdout.on('data', function (data) {
            var message = parseMessage(data);
            cacheAll.push(message);
            cacheLast = message;
            if (!option.silent)
                info('default', message);
        });
        process.on('close', function (code) { return resolve([code, cacheLast, cacheAll]); });
    });
};
var parseMessage = function (buffer) {
    return trimEnd.trimEnd_1(buffer.toString().trim(), '\n')
        .replace(/\r/g, '\n')
        .replace(/\n{2,}/g, '');
};

exports["default"] = main;
